--
--  Copyright (C) 2005 Cognovis
--
--  This file is part of dotLRN.
--
--  dotLRN is free software; you can redistribute it and/or modify it under the
--  terms of the GNU General Public License as published by the Free Software
--  Foundation; either version 2 of the License, or (at your option) any later
--  version.
--
--  dotLRN is distributed in the hope that it will be useful, but WITHOUT ANY
--  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
--  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
--  details.
--

-- The dotlrn-videos applet's implimentation of the dotlrn applet contract
--
-- 
--
-- $Id: dotlrn-videos-create.sql
--

create function inline_0()
returns integer as '
declare
	foo integer;
begin
	-- create the implementation
	foo := acs_sc_impl__new (
		''dotlrn_applet'',
		''dotlrn_data_aggregator'',
		''dotlrn_data_aggregator''
	);

	-- GetPrettyName
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''GetPrettyName'',
	       ''dotlrn_data_aggregator::get_pretty_name'',
	       ''TCL''
	);

	-- AddApplet
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''AddApplet'',
	       ''dotlrn_data_aggregator::add_applet'',
	       ''TCL''
	);

	-- RemoveApplet
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''RemoveApplet'',
	       ''dotlrn_data_aggregator::remove_applet'',
	       ''TCL''
	);

	-- AddAppletToCommunity
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''AddAppletToCommunity'',
	       ''dotlrn_data_aggregator::add_applet_to_community'',
	       ''TCL''
	);

	-- RemoveAppletFromCommunity
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''RemoveAppletFromCommunity'',
	       ''dotlrn_data_aggregator::remove_applet_from_community'',
	       ''TCL''
	);

	-- AddUser
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''AddUser'',
	       ''dotlrn_data_aggregator::add_user'',
	       ''TCL''
	);

	-- RemoveUser
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''RemoveUser'',
	       ''dotlrn_data_aggregator::remove_user'',
	       ''TCL''
	);

	-- AddUserToCommunity
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''AddUserToCommunity'',
	       ''dotlrn_data_aggregator::add_user_to_community'',
	       ''TCL''
	);

	-- RemoveUserFromCommunity
	foo := acs_sc_impl_alias__new (
	       ''dotlrn_applet'',
	       ''dotlrn_data_aggregator'',
	       ''RemoveUserFromCommunity'',
	       ''dotlrn_data_aggregator::remove_user_from_community'',
	       ''TCL''
	);

    -- AddPortlet
    foo := acs_sc_impl_alias__new (
        ''dotlrn_applet'',
        ''dotlrn_data_aggregator'',
        ''AddPortlet'',
        ''dotlrn_data_aggregator::add_portlet'',
        ''TCL''
    );

    -- RemovePortlet
    foo := acs_sc_impl_alias__new (
        ''dotlrn_applet'',
        ''dotlrn_data_aggregator'',
        ''RemovePortlet'',
        ''dotlrn_data_aggregator::remove_portlet'',
        ''TCL''
    );

    -- Clone
    foo := acs_sc_impl_alias__new (
        ''dotlrn_applet'',
        ''dotlrn_data_aggregator'',
        ''Clone'',
        ''dotlrn_data_aggregator::clone'',
        ''TCL''
    );

    foo := acs_sc_impl_alias__new (
        ''dotlrn_applet'',
        ''dotlrn_data_aggregator'',
        ''ChangeEventHandler'',
        ''dotlrn_data_aggregator::change_event_handler'',
        ''TCL''
    );

	-- Add the binding
	perform acs_sc_binding__new (
	    ''dotlrn_applet'',
	    ''dotlrn_data_aggregator''
	);

	return 0;

end;' language 'plpgsql';
select inline_0();
drop function inline_0();
